package edu.harvard.mgh.purcell.gplink.forms;

import edu.harvard.mgh.purcell.gplink.mainGUI.*;
import edu.harvard.mgh.purcell.gplink.base_form.*;

/**
 * A form that generates a PLINK command that gets a basic summery
 * of an input file set.
 * @author Kathe Todd-Brown
 */
@SuppressWarnings("serial")
public class ValidateForm extends Forms {

	/**
	 * Create a form with the appropreate title.
	 * @param mf the base frame this dialog is based on.
	 */
	public ValidateForm(MainFrame mf) {
		super(mf, "Validate fileset");
	}

	/**
	 * Do nothing, there isn't any body to create.
	 */
	@Override
	protected void createBody() {
		return;
	}

	/**
	 * Do nothing, there isn't any body to initalize.
	 */
	@Override
	protected void initalize() {
		return;
	}

	/**
	 * Return true since the non-existant body is always valid.
	 * @return true, always
	 */
	@Override
	protected boolean isBodyValid() {
		return true;
	}

	/**
	 * Since there is no body return ""
	 * @return an empty string, always
	 */
	@Override
	protected String processBody() {
		return "";
	}

}
